﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;

namespace MyAddin96
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("1ECC2436-B7F7-4718-BD75-41652EE09047"), ProgId("MyAddin96.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private AddinExpress.XL.ADXExcelTaskPanesManager adxExcelTaskPanesManager1;
        private AddinExpress.XL.ADXExcelTaskPanesCollectionItem myTaskPanesCollectionItem;
        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonCheckBox adxRibbonCheckBox1;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxExcelTaskPanesManager1 = new AddinExpress.XL.ADXExcelTaskPanesManager(this.components);
            this.myTaskPanesCollectionItem = new AddinExpress.XL.ADXExcelTaskPanesCollectionItem(this.components);
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxRibbonCheckBox1 = new AddinExpress.MSO.ADXRibbonCheckBox(this.components);
            // 
            // adxExcelTaskPanesManager1
            // 
            this.adxExcelTaskPanesManager1.Items.Add(this.myTaskPanesCollectionItem);
            this.adxExcelTaskPanesManager1.SetOwner(this);
            // 
            // adxExcelTaskPanesCollectionItem1
            // 
            this.myTaskPanesCollectionItem.AlwaysShowHeader = true;
            this.myTaskPanesCollectionItem.CloseButton = true;
            this.myTaskPanesCollectionItem.IsHiddenStateAllowed = false;
            this.myTaskPanesCollectionItem.IsMinimizedStateAllowed = false;
            this.myTaskPanesCollectionItem.Position = AddinExpress.XL.ADXExcelTaskPanePosition.Bottom;
            this.myTaskPanesCollectionItem.Splitter = AddinExpress.XL.ADXExcelSplitter.None;
            this.myTaskPanesCollectionItem.TaskPaneClassName = "MyAddin96.MyTaskPane";
            this.myTaskPanesCollectionItem.UseOfficeThemeForBackground = true;
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "COM add-in + XLL add-in";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_ea31239eb84543f4bfafa0d57bc18e61";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "XLL settings";
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonCheckBox1);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_bfa33b11095a4d46be5029b4747082b8";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonCheckBox1
            // 
            this.adxRibbonCheckBox1.Caption = "Show extended error info";
            this.adxRibbonCheckBox1.Id = "adxRibbonCheckBox_592f41e7e4284db5a6740dff0a376c5c";
            this.adxRibbonCheckBox1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.adxRibbonCheckBox1.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.showPaneCheckBox_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "MyAddin96";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
            this.OnSendMessage += new AddinExpress.MSO.ADXSendMessage_EventHandler(this.AddinModule_OnSendMessage);

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        public void ShowPane(string message)
        {
            MyTaskPane myPane = (MyTaskPane)myTaskPanesCollectionItem.TaskPaneInstance;
            if (myPane == null) myPane = (MyTaskPane)myTaskPanesCollectionItem.CreateTaskPaneInstance();
            myPane.SetText(message);
            myPane.Show(); // will show up only if IsChecked is true
        }

        bool isCheckBoxTicked = false;
        private void showPaneCheckBox_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            isCheckBoxTicked = pressed;
        }

        // if IsChecked is false, the pane will not show
        public bool IsCheckBoxTicked
        {
            get { return isCheckBoxTicked;}
        }

        private const int WM_USER = 1024;
        public int WM_ShowMyPane = WM_USER + 1800;

        private void AddinModule_OnSendMessage(object sender, ADXSendMessageEventArgs e)
        {
            if (e.Message == WM_ShowMyPane)
            {
                XLLModule theXLL = MyAddin96.XLLModule.CurrentInstance;
                if (theXLL != null)
                {
                    if (theXLL.Messages.Count > 0)
                    {
                        string message = theXLL.Messages[theXLL.Messages.Count - 1].ToString();
                        ShowPane(message);
                    }
                }
            }
        } 
    }
}

